# GITEA DRONE CI DOCKER-COMPOSE DEPLOYEMENT

Stack de déployement de Gitea avec Drone CI pour héberger son code avec des runners pour le CI/CD

[Gitea site](https://gitea.io)

[Drone CI site](https://www.drone.io)

## PRE-REQUIS

- [Docker](https://www.google.com)
- [Docker-compose](https://www.google.com)

## USAGE

:warning: deployer gitea en premier (sans drone ci)

### GITEA

- Renseigner le fichier .env avec le bon nom de domaine

> nécessite une configuration nginx fonctionnelle

- deployer gitea:
```bash
docker-compose up -d
```

- Créer l'utilisateur admin avec son mot de passe

- Dans le profil de l'utilisateur, aller à l'onglet application pour créer l'authentification Oauth2 pour le drone (DRONE_GITEA_CLIENT_ID, DRONE_GITEA_CLIENT_SECRET) et renseigner celles-ci dans le fichier .env

- Renseigner le DRONE_RPC_SECRET (aéatoire, c'est pour authentifier le drone runner et le drone server entre eux)

### DRONE CI

- Renseigner le fichier .env avec le bon nom de domaine, le DRONE_RPC_SECRET (aéatoire, c'est pour authentifier le drone runner et le drone server entre eux) ainsi que le nom d'utilisateur et le mot de passe de l'admin créé plus haut


- deployer drone ci:
```bash
docker-compose up -d
```

## CONFIGURATION

- gitea/conf/app.ini
```
# DNS
[server]
DOMAIN           = gitea.mondomaine.tld
SSH_DOMAIN       = gitea.mondomaine.tld
ROOT_URL         = https://gitea.mondomaine.tld/
LANDING_PAGE     = explore

# SSO
[service]
DISABLE_REGISTRATION              = true
ALLOW_ONLY_EXTERNAL_REGISTRATION  = true
[openid]
ENABLE_OPENID_SIGNIN = true

# THEMES
[ui]
THEMES = gitea,arc-green,github,matrix,tangerine-dream,earl-grey
DEFAULT_THEME = gitea
```

> Pour le SSO, aller dans les la partie administration du site sur gitea, onglet source d'authentificationet ajouter une source d'authentification (pour keycloak: https://adresse-du-keycloak/auth/realms/gregan/.well-known/openid-configuration)

## TO DO

- [ ] Config all via .env

## CONTRIBUTION

this docker-compose file is based on https://github.com/ruanbekker/drone-gitea-traefik-docker-blogpost